CREATE USER TEST_USER IDENTIFIED BY 1234;
GRANT RESOURCE TO TEST_USER;
GRANT CONNECT TO TEST_USER;
GRANT CREATE VIEW TO TEST_USER;
GRANT CREATE SESSION TO TEST_USER;
GRANT UNLIMITED TABLESPACE TO TEST_USER;

CREATE TABLE TEST_USER.COMPANY (
  ID NUMBER(38),
  NAME VARCHAR2(255),
  LAST_UPDATE_TS TIMESTAMP(9) NOT NULL,
  PRIMARY KEY (ID)
);

CREATE SEQUENCE TEST_USER.COMPANY_SEQUENCE START WITH 1 INCREMENT BY 1 CACHE 100;

CREATE TABLE TEST_USER.PERSON (
  ID NUMBER(38),
  FIRST_NAME VARCHAR2(255),
  LAST_NAME VARCHAR2(255),
  LAST_UPDATE_TS TIMESTAMP(9) NOT NULL,
  PRIMARY KEY (ID)
);

CREATE SEQUENCE TEST_USER.PERSON_SEQUENCE START WITH 1 INCREMENT BY 1 CACHE 100;

CREATE TABLE TEST_USER.ADDRESS (
  ID NUMBER(38),
  FIRST_LINE VARCHAR2(1024),
  SECOND_LINE VARCHAR2(1024),
  CITY VARCHAR2(255),
  STATE VARCHAR2(2),
  ZIPCODE NUMBER(5),
  LAST_UPDATE_TS TIMESTAMP(9) NOT NULL,
  PRIMARY KEY (ID)
);

CREATE SEQUENCE TEST_USER.ADDRESS_SEQUENCE START WITH 1 INCREMENT BY 1 CACHE 100;

CREATE TABLE TEST_USER.EMPLOYEE (
  ID NUMBER(38),
  PERSON_ID NUMBER(38),
  COMPANY_ID NUMBER(38),
  LAST_UPDATE_TS TIMESTAMP(9) NOT NULL,
  CONSTRAINT FK_PERSON_EMPLOYEE FOREIGN KEY (PERSON_ID) REFERENCES TEST_USER.PERSON (ID),
  CONSTRAINT FK_COMPANY_EMPLOYEE FOREIGN KEY (COMPANY_ID) REFERENCES TEST_USER.COMPANY (ID),
  PRIMARY KEY (ID)
);

CREATE SEQUENCE TEST_USER.EMPLOYEE_SEQUENCE START WITH 1 INCREMENT BY 1 CACHE 100;

CREATE TABLE TEST_USER.RESIDENCE (
  ID NUMBER(38),
  PERSON_ID NUMBER(38),
  ADDRESS_ID NUMBER(38),
  LAST_UPDATE_TS TIMESTAMP(9) NOT NULL,
  CONSTRAINT FK_PERSON_RESIDENCE FOREIGN KEY (PERSON_ID) REFERENCES TEST_USER.PERSON (ID),
  CONSTRAINT FK_ADDRESS_RESIDENCE FOREIGN KEY (ADDRESS_ID) REFERENCES TEST_USER.ADDRESS (ID),
  PRIMARY KEY (ID)
);

CREATE SEQUENCE TEST_USER.RESIDENCE_SEQUENCE START WITH 1 INCREMENT BY 1 CACHE 100;